/*
Amulet.

(C) J Whitham 1994
*/

#include <fastgraf.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

#define MaxX		( 40 )
#define MaxY		( 28 )
#define GridSize	( 16 )
#define Available ( 255 )

char				* Buffer [ 257 ] ;
char				Temp [ 40 ] ;
char				Naming [ 257 ][ 12 ] ;
unsigned char	Original [ 16 ][ 16 ] ;
int				Selected = 1 ;
int				Quit = 0 ;
int				Drag = 0 ;
char				Filename [ 40 ] ;
int				Picked ;
unsigned char	Screen [ MaxX ][ MaxY ] ;
unsigned char	Restore [ MaxX ][ MaxY ] ;

void Update ( int X , int Y ) ;
void UpdateSelected ( void ) ;
void Save ( void ) ;
void DoRestore ( void ) ;
void StraightConvert ( char * Anim ) ;

void main ( void )
{
	int		I , X , Y , CursorX , CursorY , Press ;
	int		ch = 0 ;
	int		Change ;
	FILE		* File ;

	printf ( "LOADING   0" ) ;
	File = fopen ( "names.raw" , "rt" ) ;
	if ( File == NULL )
	{
		printf ( "Error 5" ) ;
		exit ( 0 ) ;
	}
	for ( I = 1 ; I < 256 ; I ++ )
	{
		fgets ( Naming [ I ] , 10 , File ) ;
	}
	fclose ( File ) ;

	for ( I = 1 ; I < 256 ; I ++ )
	{
		printf ( "\rLOADING %3d" , I ) ;
		sprintf ( Temp , "GAMECHR.%d" , I ) ;
		File = fopen ( Temp , "rb" ) ;
		Buffer [ I ] = malloc ( ( GridSize / 2 ) * GridSize ) ;
		if ( Buffer [ I ] == NULL )
		{
			printf ( "Out of Memory" ) ;
			exit ( 0 ) ;
		}
		if ( File == NULL )
		{
			if ( I > 2 )
			{
				Buffer [ I ] = Buffer [ 2 ] ;
			} else {
				printf ( "\nFATAL LOADING ERROR\n" ) ;
				exit ( 0 ) ;
			}
			printf ( " U" ) ;
		} else {
			if ( fread ( Original , sizeof ( Original ) , 1 , File ) != 1 )
			{
				printf ( "\nError 60" ) ;
				exit ( 0 ) ;
			}
			StraightConvert ( Buffer [ I ] ) ;
			printf ( " D" ) ;
			fclose ( File ) ;
		}
	}
	printf ( "\n" ) ;
	if ( ! fg_testmode ( 18 , 1 ) )
	{
		printf ( "VGA required" ) ;
		exit ( 0 ) ;
	}
	fg_setmode ( 18 ) ;
	fg_setrgb ( 1 , 0 , 0 , 0 ) ;
	fg_fontsize ( 16 ) ;
	fg_move ( 216 , 248 ) ;
	fg_setcolor ( 1 ) ;
	fg_print ( "LEVELDIT (C) J Whitham '94" , 26 ) ;
	for ( I = 0 ; I < 63 ; I ++ )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}

	fg_waitfor ( 18 ) ;
	for ( ; I > 0 ; I -- )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}
	if ( fg_mouseini () < 2 )
	{
		fg_setmode ( 3 ) ;
		printf ( "Microsoft-compatible 2 or 3 button mouse required." ) ;
		exit ( 0 ) ;
	}
	fg_mousevis ( 0 ) ;
	fg_mouselim ( 20 , 120 , 40 , 60 ) ;

	fg_move ( 0 , 16 ) ;
	fg_setcolor ( 15 ) ;
	fg_print ( "Please select a level:" , 22 ) ;
	fg_setcolor ( 12 ) ;
	fg_move ( 0 , 80 ) ;
	fg_print ( "Quick help: select a level" , 26 ) ;
	fg_move ( 0 , 96 ) ;
	fg_print ( "by clicking on the left\\right" , 29 ) ;
	fg_move ( 0 , 112 ) ;
	fg_print ( "buttons. Clicking on the end of" , 31 ) ;
	fg_move ( 0 , 128 ) ;
	fg_print ( "the arrows moves fast, on the" , 29 ) ;
	fg_move ( 0 , 144 ) ;
	fg_print ( "other side moves slow. Press OK" , 31 ) ;
	fg_move ( 0 , 160 ) ;
	fg_print ( "when you've finished." , 21 ) ;
	fg_box ( 20 , 120 , 40 , 60 ) ;
	fg_move ( 62 , 58 ) ;
	fg_setcolor ( 14 ) ;
	fg_print ( "OK" , 2 ) ;
	fg_move ( 40 , 41 ) ;
	fg_draw ( 21 , 50 ) ;
	fg_draw ( 40 , 59 ) ;
	fg_move ( 100 , 41 ) ;
	fg_draw ( 119 , 50 ) ;
	fg_draw ( 100 , 59 ) ;
	fg_setcolor ( 7 ) ;
	fg_move ( 40 , 38 ) ;
	I = 1 ;
	sprintf ( Temp , "%d" , I ) ;
	fg_print ( Temp , strlen ( Temp ) ) ;
	fg_mousevis ( 1 ) ;
	while ( ! Quit )
	{
		Change = 0 ;
		fg_mousepos ( & X , & Y , & Press ) ;

		if ( Press > 0 )
		{
			if ( X < 41 )
			{
				if ( X < 31 )
				{
					I -= 5 ;
				} else {
					I -- ;
				}
				Change = 1 ;
			} else {
				if ( X > 99 )
				{
					if ( X > 109 )
					{
						I += 5 ;
					} else {
						I ++ ;
					}
					Change = 1 ;
				} else {
					if ( X > 58 && X < 74 )
					{
						Quit = 1 ;
					}
				}
			}

			while ( Press > 0 )
			{
				fg_mousepos ( & X , & Y , & Press ) ;
			}
			if ( kbhit () )
			{
				if ( getch () == 27 )
				{
					fg_setmode ( 3 ) ;
					exit ( 0 ) ;
				}
			}
		}
		if ( I < 1 )
		{
			I += Available ;
		}
		if ( I > Available )
		{
			I -= Available ;
		}
		if ( Change )
		{
			fg_setcolor ( 0 ) ;
			fg_rect ( 40 , 80 , 22 , 38 ) ;
			fg_setcolor ( 7 ) ;
			fg_move ( 40 , 38 ) ;
			sprintf ( Temp , "%d" , I ) ;
			fg_print ( Temp , strlen ( Temp ) ) ;
		}
	}
	Picked = I ;

	sprintf ( Filename , "GAMELEVL.%d" , Picked ) ;

	if (( File = fopen ( Filename , "rb" ) ) != NULL )
	{
		if ( fread ( Screen , sizeof ( Screen ) , 1 , File ) != 1 )
		{
			fg_setmode ( 3 ) ;
			printf ( "Couldn't read %s" , Filename ) ;
			exit ( 0 ) ;
		}
		fclose ( File ) ;
		Save () ;
	}

	fg_mousevis ( 0 ) ;
	fg_erase () ;
	fg_mouselim ( 1 , 637 , 1 , 476 ) ;

	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			Update ( X , Y ) ;
		}
	}
	fg_setcolor ( 15 ) ;
	fg_move ( 0 , 448 ) ;
	fg_draw ( 639 , 448 ) ;
	fg_move ( 0 , 469 ) ;
	fg_fontsize ( 16 ) ;
	fg_print ( "LEVELDIT" , 8 ) ;
	fg_move ( 70 , 448 ) ;
	fg_draw ( 70 , 479 ) ;
	fg_move ( 75 , 479 ) ;
	fg_fontsize ( 8 ) ;
	fg_setcolor ( 14 ) ;
	fg_print ( "RESTORE" , 7 ) ;
	fg_move ( 75 , 469 ) ;
	fg_print ( "SAVE" , 4 ) ;
	fg_move ( 75 , 459 ) ;
	fg_print ( "QUIT" , 4 ) ;
	fg_setcolor ( 15 ) ;
	fg_move ( 132 , 448 ) ;
	fg_draw ( 132 , 479 ) ;
	fg_move ( 70 , 470 ) ;
	fg_draw ( 132 , 470 ) ;
	fg_move ( 70 , 460 ) ;
	fg_draw ( 132 , 460 ) ;

	fg_setcolor ( 2 ) ;
	fg_move ( 200 , 464 ) ;
	fg_draw ( 280 , 464 ) ;

	fg_setcolor ( 15 ) ;
	fg_move ( 200 , 448 ) ;
	fg_draw ( 200 , 479 ) ;
	fg_move ( 240 , 448 ) ;
	fg_draw ( 240 , 479 ) ;
	fg_move ( 280 , 448 ) ;
	fg_draw ( 280 , 479 ) ;
	fg_move ( 300 , 448 ) ;
	fg_draw ( 300 , 479 ) ;
	fg_move ( 350 , 448 ) ;
	fg_draw ( 350 , 479 ) ;
	fg_move ( 400 , 448 ) ;
	fg_draw ( 400 , 479 ) ;

	fg_fontsize ( 16 ) ;
	fg_setcolor ( 3 ) ;
	fg_move ( 216 , 472 ) ;
	fg_print ( "UP" , 2 ) ;
	fg_move ( 256 , 472 ) ;
	fg_print ( "DN" , 2 ) ;
	fg_move ( 310 , 472 ) ;
	fg_setcolor ( 14 ) ;
	fg_print ( "FILL" , 4 ) ;
	fg_move ( 360 , 472 ) ;
	fg_print ( "DRAG" , 4 ) ;

	fg_fontsize ( 8 ) ;
	fg_mousevis ( 1 ) ;
	UpdateSelected () ;

	Quit = 0 ;
	Drag = 0 ;
	while ( ! Quit )
	{
		fg_mousepos ( & X , & Y , & Press ) ;

		if ( Press > 0 )
		{
			if ( Y < 448 )
			{
				CursorX = X / GridSize ;
				CursorY = Y / GridSize ;
				Screen [ CursorX ][ CursorY ] = Selected ;
				fg_mousevis ( 0 ) ;
				Update ( CursorX , CursorY ) ;
				fg_mousevis ( 1 ) ;
			} else {
				if ( X < 132 && X > 75 )
				{
					if ( Y > 470 )
					{
						/* Restore */
						DoRestore () ;
					} else {
						if ( Y > 460 )
						{
							/* Save */
							Save () ;
						} else {
							/* Quit */
							Quit = 1 ;
						}
					}
				} else {
					if ( X > 200 && X < 280 )
					{
						if ( X < 240 )
						{
							/* up */
							if ( Y > 464 )
							{
								Selected ++ ;
							} else {
								Selected += 5 ;
							}
						} else {
							/* down */
							if ( Y > 464 )
							{
								Selected -- ;
							} else {
								Selected -= 5 ;
							}
						}
						if ( Selected > Available )
						{
							Selected -= Available ;
						}
						if ( Selected < 1 )
						{
							Selected += Available ;
						}
						UpdateSelected () ;
					} else {
						if ( X > 300 && X < 350 )
						{
							fg_setcolor ( 0 ) ;
							fg_rect ( 240 , 400 , 200 , 230 ) ;
							fg_move ( 248 , 225 ) ;
							fg_setcolor ( 14 ) ;
							fg_print ( "REALLY WIPE (Y\\N)?" , 18 ) ;
							ch = toupper ( getch () ) ;
							for ( X = 0 ; X < MaxX ; X ++ )
							{
								for ( Y = 0 ; Y < MaxY ; Y ++ )
								{
									if ( ch == 'Y' )
									{
										Screen [ X ][ Y ] = Selected ;
									}
									Update ( X , Y ) ;
								}
							}
						} else {
							if ( X > 350 && X < 400 )
							{
								fg_mousevis ( 0 ) ;
								fg_setcolor ( 0 ) ;
								fg_rect ( 352 , 376 , 469 , 479 ) ;
								fg_setcolor ( 7 ) ;
								fg_move ( 352 , 478 ) ;
								if ( Drag )
								{
									Drag = 0 ;
									fg_print ( "OFF" , 3 ) ;
								} else {
									Drag = 1 ;
									fg_print ( "ON" , 2 ) ;
								}
								fg_mousevis ( 1 ) ;
							}
						}
					}
				}
			}
			while ( Press > 0 )
			{
				fg_mousepos ( & X , & Y , & Press ) ;
				if ( Drag && Y < 448 )
				{
					Press = 0 ;
				}
			}
		}
		if ( kbhit () )
		{
			if ( getch () == 27 )
			{
				Quit = 1 ;
			}
		}
	}
	for ( I = 1 ; I < 256 ; I ++ )
	{
		free ( Buffer [ I ] ) ;
	}
	fg_setmode ( 3 ) ;
}


void UpdateSelected ( void )
{
	int		I ;
	
	fg_move ( 150 , 465 ) ;
	fg_putimage ( Buffer [ Selected ] , GridSize / 2 , GridSize ) ;
	fg_setcolor ( 0 ) ;
	fg_rect ( 135 , 199 , 469 , 478 ) ;
	fg_move ( 135 , 478 ) ;
	fg_setcolor ( 4 ) ;
	if ( Naming [ Selected ][ 0 ] == '$' )
	{
		strcpy ( Temp , "UNTITLED" ) ;
	} else {
		strcpy ( Temp , Naming [ Selected ] ) ;
	}
	for ( I = 0 ; I < 12 ; I ++ )
	{
		if ( (int) Temp [ I ] < 32 )
		{
			Temp [ I ] = '\0' ;
		}
	}

	fg_print ( Temp , strlen ( Temp ) ) ;
	sprintf ( Temp , "%d   " , Selected ) ;
	fg_setcolor ( 0 ) ;
	fg_rect ( 170 , 199 , 449 , 465 ) ;
	fg_setcolor ( 7 ) ;
	fg_move ( 170 , 465 ) ;
	fg_print ( Temp , 3 ) ;
}

void Update ( int X , int Y )
{
	fg_move ( ( X * GridSize ) , ( Y * GridSize ) + GridSize - 1 ) ;
	fg_putimage ( Buffer [ Screen [ X ][ Y ] ] , GridSize / 2 , GridSize ) ;
}

void Save ( void )
{
	int		X , Y , I ;
	FILE		* File = fopen ( Filename , "wb" ) ;


	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			I = Screen [ X ][ Y ] ;
			if ( I < 1 || I > 255 )
			{
				Screen [ X ][ Y ] = 1 ;
			}
			Restore [ X ][ Y ] = Screen [ X ][ Y ] ;
		}
	}

	if ( File == NULL )
	{
		fg_setmode ( 3 ) ;
		printf ( "Couldn't open save" ) ;
		exit ( 0 ) ;
	}
	fwrite ( Screen , sizeof ( Screen ) , 1 , File ) ;
	fclose ( File ) ;
}

void DoRestore ( void )
{
	int		X , Y ;


	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			Screen [ X ][ Y ] = Restore [ X ][ Y ] ;
			Update ( X , Y ) ;
		}
	}
}

void StraightConvert ( char * Anim )
{
	int	X , Y , K , J ;


	J = 0 ;
	for ( Y = 15 ; Y > -1 ; Y -- )
	{
		for ( X = 0 ; X < 16 ; X += 2 )
		{
			K = ( Original [ X ][ Y ] * 16 ) +
					Original [ X + 1 ][ Y ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}

